unit UConfig;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls,IniFiles, Spin, nkprinters, ComCtrls;

type
  TconfigForm = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    OptionGroupBox: TGroupBox;
    ignoreBlankColChkBox: TCheckBox;
    ignoreConfirmChkBox: TCheckBox;
    PageGroupBox: TGroupBox;
    PageMinSpinEdit: TSpinEdit;
    PageMaxSpinEdit: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    PrintLineNumberChkBox: TCheckBox;
    PrintHeader: TCheckBox;
    PrintFrameLine: TCheckBox;
    GroupBox1: TGroupBox;
    isLandscape: TRadioButton;
    isPortrait: TRadioButton;
    GroupBox2: TGroupBox;
    ChangePaperSizeCheckbox: TCheckBox;
    ChangePaperSizeCombobox: TComboBox;
    SizeLabel: TLabel;
    OrientationChangeable: TLabel;
    papersizechangeable: TLabel;
    HideTaskbar: TCheckBox;
    Tumeru: TCheckBox;
    Panel1: TPanel;
    Label1: TLabel;
    tabSpaceSpinBox: TSpinEdit;
    label2: TLabel;
    Label5: TLabel;
    LineSpaceHeight: TSpinEdit;
    Label6: TLabel;
    yohakuLabel: TLabel;
    OffsetTrackBar: TTrackBar;
    value120: TLabel;
    value200: TLabel;
    YohakuValue: TLabel;
    value0: TLabel;
    newPageCharAvailable: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OffsetTrackBarChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ChangePaperSizeCheckboxClick(Sender: TObject);
    procedure ChangePaperSizeComboboxChange(Sender: TObject);
  private
    FFileName: String; // ݒ[hAZ[ut@C̖O
    FPaperSizeNumber: Integer; // DMPAPER_A4Ƃ̔ԍ
    procedure SaveIniFile;
    procedure LoadIniFile;
  end;

var
  configForm: TconfigForm;

//procedure SetDefaultPrinter(index: Integer);

implementation

{$R *.DFM}

uses
  main; // default printer̕ύXɕt, winspool, printers;

{********************************************
 *
 * ftHgv^[̕ύX
 *}
{procedure SetDefaultPrinter(Index: Integer);
var Device, Driver, Port: array[0..511] of Char;
    hDevMode: THandle;
    hPrinter: THandle;
    pInfo2: ^TPrinterInfo2;
    Size: DWORD;
begin
  Printer.PrinterIndex := Index;
  // foCX𓾂
  Printer.GetPrinter(Device, Driver, Port, hDevMode);

  // v^nhB
  Win32Check(OpenPrinter(Device, hPrinter, Nil));
  try
    // Printer_Info_2 ɕKvȃobt@TCY擾
    WinSpool.GetPrinter(hPrinter, 2, pInfo2, 0, @size);

    // obt@m
    GetMem(pInfo2, size);
    try
      // v^擾
      Win32Check(WinSpool.GetPrinter(hPrinter, 2, pInfo2, Size, @size));

      // ftHgv^ɂ
      pInfo2.Attributes := pInfo2.Attributes or
                           PRINTER_ATTRIBUTE_DEFAULT;

      // v^v^փZbg
      Win32Check(WinSpool.SetPrinter(hPrinter, 2, pInfo2,
                          PRINTER_CONTROL_SET_STATUS));
    finally
      FreeMem(pInfo2);
    end;
  finally
    ClosePrinter(hPrinter);
  end;
end;}

{*********************************************}
procedure TConfigForm.LoadIniFile;
var
  setting: TIniFile;
  papnum : Integer;
begin
  setting := TIniFile.Create(FFilename);
  with setting do
  begin
    ignoreBlankColChkBox.Checked            := ReadBool('Option', 'SkipBlankLine', false);
    tabSpaceSpinBox.Value                   := ReadInteger('Option', 'TabSpace', 4);
    ignoreConfirmChkBox.Checked             := ReadBool('Option', 'IgnoreConfirm',false);
    PrintLineNumberChkBox.Checked           := ReadBool('Option', 'PrintLineNumber', false);
    OffsetTrackBar.Position                 := ReadInteger('Option', 'Offset', 120);
    LineSpaceHeight.Value                   := ReadInteger('Option', 'LineSpaceHeight', 0);
    PrintHeader.Checked                     := ReadBool('Option', 'PrintHeader', true);
    PrintFrameLine.Checked                  := ReadBool('Option', 'PrintFrameLine', true);
    HideTaskbar.Checked                     := ReadBool('Option','HideTaskbar', false);
    Tumeru.Checked                          := not ReadBool('Option','NextFileWithNewSheet', true);
    newPageCharAvailable.Checked            := ReadBool('Option','NewPageCharAvailable',false);

    Form1.FontDialog1.Font.Size             := ReadInteger('Font', 'Size', 7);
    Form1.FontDialog1.Font.Name             := ReadString('Font', 'Name', 'lr ');
    //alwaysLandscape                         := ReadBool('Printer', 'AlwaysLandscape', false);
    if(ReadBool('Printer','poLandscape',true)=true) then
      isLandscape.Checked := true
    else
      isPortrait.Checked := true;

    // pTCYɊւ
    ChangePaperSizeCheckBox.Checked         := ReadBool('Printer','ChangePaperSize', true);
    if (nkPcPaperSize in NkPrinter.PrintCaps) and (nkAvPaperSize in nkPrinter.AvailInfos) then
    begin
      papnum := ReadInteger('Printer','PaperSize',NkPrinter.PaperSizeNumber);
      if NkPrinter.HasPaperSizeNumber(papnum) then
      begin
        NkPrinter.PaperSizeNumber := papnum;
        NkPrinter.ApplySettings;
      end
      else
      begin
        // pTCYs̎(ΉłȂTCY̎)
        WriteInteger('Printer', 'PaperSize', NkPrinter.PaperSizeNumber);
      end;
    end;


    FPaperSizeNumber                        := ReadInteger('Printer','PaperSize',DMPAPER_A4);
     //WriteInteger('Font','Pitch', FontDialog1.Font.Pitch);
    free;
  end;
end;


{*****************************************}
procedure TConfigForm.SaveIniFile;
var
  setting: TIniFile;
begin
  setting := TIniFile.Create(FFileName);
  with setting do
  begin
    WriteBool('Option', 'SkipBlankLine', ignoreBlankColChkBox.Checked);
    WriteInteger('Option', 'TabSpace', tabSpaceSpinBox.Value);
    WriteBool('Option', 'IgnoreConfirm',ignoreConfirmChkBox.Checked);
    WriteBool('Option', 'PrintLineNumber', PrintLineNumberChkBox.Checked);
    WriteInteger('Option', 'Offset', OffsetTrackBar.Position);
    WriteInteger('Option', 'LineSpaceHeight', LineSpaceHeight.Value);
    WriteBool('Option', 'PrintHeader', PrintHeader.Checked);
    WriteBool('Option', 'PrintFrameLine', PrintFrameLine.Checked);
    WriteBool('Option','HideTaskbar', HideTaskbar.Checked);
    WriteBool('Option','NextFileWithNewSheet', not Tumeru.Checked);
    WriteBool('Option','NewPageCharAvailable', newPageCharAvailable.Checked);
    WriteInteger('Font', 'Size', Form1.FontDialog1.Font.Size);
    WriteString('Font', 'Name', Form1.FontDialog1.Font.Name);
    WriteBool('Printer','poLandscape', isLandscape.Checked);
    WriteBool('Printer','ChangePaperSize', ChangePaperSizeCheckbox.Checked);
    WriteInteger('Printer','PaperSize', NkPrinter.PaperSizeNumber); 
    free;
  end;

end;

{****************************************************}
{ cancelAiniFileǂŁAύX͔j@      }
procedure TConfigForm.CancelBtnClick(Sender: TObject);
begin
  LoadIniFile;
end;

{*************************************************}
{ OKAiniFIleŁAύX͗L     }
procedure TConfigForm.OKBtnClick(Sender: TObject);
begin
  SaveIniFile;
end;

{**************************************************}
procedure TConfigForm.FormCreate(Sender: TObject);
begin
  FFileName := ChangeFileExt(Application.ExeName, '.ini');
  LoadIniFile;
end;


    
{**************************************************}
{ tH[̃N[Y                               }
{ tHg̕ύX̂ŁAiniFIleZ[uĂ}
procedure TconfigForm.FormDestroy(Sender: TObject);
begin
  saveIniFile;
end;

procedure TconfigForm.OffsetTrackBarChange(Sender: TObject);
begin
  YohakuValue.Caption := IntToStr(OffsetTrackBar.Position);
end;

procedure TconfigForm.FormShow(Sender: TObject);
var
  a : boolean;
  b : boolean;
begin
  // ]̑傫̃gbNo[Ǝw肳ꂽƂw悤ɂ
  OffsetTrackBar.OnChange(self);


  // ȉAp̌̕ύXɊւ
  a := nkPcOrientation in NkPrinter.PrintCaps;  // fobO̕]ŁAa=falseɂăeXgo悤ɂĂ

  if a then
  begin
    OrientationChangeable.Visible := false;
    isLandscape.Enabled := true;
    isPortrait.Enabled := true;
  end
  else
  begin
    OrientationChangeable.Visible := true;
    isLandscape.Enabled := false;
    isPortrait.Enabled := false;
  end;


  // ȉAp̃TCY̕ύXɊւ

  b := (nkPcPaperSize in NkPrinter.PrintCaps) and (nkAvPaperSize in nkPrinter.AvailInfos); // fobOɕ]ł悤ɁAbƂϐɑ

  if b then
  begin
    papersizechangeable.Visible := false;
    ChangePaperSizeCheckbox.Enabled := true;
    ChangePaperSizeCheckboxClick(self);

    ChangePaperSizeCombobox.Items := NkPrinter.PaperSizeNames;
    ChangePaperSizeCombobox.ItemIndex := NkPrinter.PaperSizeIndex;
  end
  else
  begin
    paperSizeChangeable.Visible := true;
    ChangePaperSizeCheckbox.Enabled := false;
    ChangePaperSizeCheckboxClick(self);

  end;


end;

procedure TconfigForm.ChangePaperSizeCheckboxClick(Sender: TObject);
begin
  if ChangePaperSizeCheckbox.Checked = true then
  begin
    ChangePaperSizeCombobox.Enabled := true;
    SizeLabel.Enabled := true;
  end
  else
  begin
    ChangePaperSizeCombobox.Enabled := false;
    SizeLabel.Enabled := false;
  end;

end;

procedure TconfigForm.ChangePaperSizeComboboxChange(Sender: TObject);
begin
  NkPrinter.PaperSizeNumber := NkPrinter.PaperSizeNumbers[ChangePaperSizeCombobox.ItemIndex];
  NkPrinter.ApplySettings;
end;



end.
