unit UPrint;

interface

uses
  classes;

type
  TSheet = Record
    SheetWidth,SheetHeight                              : integer; // pŜ̑傫
    // frame
    FrameTMar,FrameLMar,FrameBMar,FrameRMar,FrameMidMar : integer; // pFrame(WordFrame+TitleFrame)̊
    WordFrameHeight,WordFrameWidth                      : integer; // WordFramȇ傫
    InfoFrameHeight,InfoFrameTBMar                      : integer; // InfoFramȇ傫
    // wordframȅ
    RegionTMar,RegionLMar,RegionBMar,RegionRMar         : integer; // WordFrameƁAۂɕ̈̊
    WordRegionHeight,WordRegionWidth                    : integer; // ۂɕ̈
    // region̏
    NumberRegion                                        : integer; // sԍp̕()
    SpaceRegion                                         : integer; // sԍƕ̕
  end;

var
  Sheet: TSheet;
  nFiles: Integer; // newLogicalPageŁAǂ`FbN̂Ɏgp
  spoolJustCreated: Boolean; // ŏ͕̈KleftpageɂȂ悤ɂ

const
  nonPrintableChar = ' ';              // s\ȕ́AXy[Xɕϊ

// ߂ĺAɗvp̖

function printFiles(files: TStringList; nextFileWithNewSheet: boolean): integer;
function printClipBoard(title, buffer: string): integer;

//----------------------------------------------------------------------

implementation

uses
  main, nkPrinters, Sysutils, Mystr, Forms, Graphics, UConfig, ReadFileAll, math,
  UTimeString,longFileName, Dialogs,Messages, Windows, Controls,StdCtrls, ShellAPI;

type
  TPageLeftRight = (leftPage, rightPage);

var
  pageNo       : Integer;  // _y[Wiŏ̃y[W͂Pj
  totalSheets  : Integer;  // ̐
  headerTitle  : string;
  headerTime   : string;
  x            : Integer;  // ʒu
  y            : Integer;  // ʒu
  charMaxWidth : Integer;  // (0`9)P̍ő̕
  numberx      : Integer;  // sԍ́ÄʒuE[Ƃď
  PageMin      : Integer;  // y[Wí͈j
  PageMax      : Integer;  // y[Wí͈j
  pageLeftRight: TPageLeftRight; // ǂ̃y[WĂ邩H
  LineNumber   : Integer;  // sԍ

procedure SheetInitialize;  forward;
procedure printBuffer(title, buffer: string); forward;
procedure DrawFrame; forward;
function NewLogicalPage: boolean; forward;
procedure beginDocument(spoolName: string); forward;
procedure endDocument; forward;
function getFileContents(filename: string; var buffer: string): boolean; forward;
function insidePageRange(pageNo: integer): boolean; forward;

{********************************

  SheetInitialize
 @ V[gpe萔̐ݒ
@@OɎs

  
  @Ȃ

  ߂l
  @Ȃ
  
 ********************************}
procedure SheetInitialize;
var
  i : integer;
begin

  with Sheet do
    begin
      { V[gŜ̑傫 }
      SheetWidth := nkPrinter.PageExtent.cx;
      SheetHeight := nkPrinter.PageExtent.cy;
      { pƊOg̊Ԃ̐ݒ }
      FrameTMar := ConfigForm.OffsetTrackBar.Position;
      FrameBMar := FrameTMar;
      FrameLMar := (FrameTMar * 5) div 4;
      FrameRMar := FrameLMar;
      FrameMidMar := FrameTMar + 20;
      { ^Cgg̑傫 }
      if ConfigForm.PrintHeader.Checked then
      begin
        InfoFrameTBMar := 20;
        InfoFrameHeight := Abs(nkPrinter.Canvas.Font.Height) + InfoFrameTBMar*2;
      end
      else
      begin
        InfoFrameTBMar := 0;
        InfoFrameHeight := 0;
      end;

      { g̑傫 }
      WordFrameHeight := SheetHeight-FrameBMar-FrameTMar-InfoFrameHeight;
      WordFrameWidth  := (SheetWidth -FrameLMar-FrameRMar-FrameMidMar) div 2;
      { gƕ̈̊ }
      RegionLMar := 50;
      RegionRMar := 50;
      RegionTMar := 30;
      RegionBMar := 30;
      { ̈̐ݒ }
      WordRegionWidth := WordFrameWidth-RegionLMar-RegionRMar;
      WordRegionHeight:= WordFrameHeight-RegionTMar-RegionBMar;
    end;{ with Sheet }

  // charMaxWidth̐ݒ
  // (ꕶ̑傫݂B)
  // propotional fontƁAɂđ傫ႤA0-9܂ł̕gāA傫𒲂ׂĂ݂
  charMaxwidth := 0;
  for i:=0 to 9 do
  begin
    if nkPrinter.Canvas.TextWidth(IntToStr(i)) > charMaxWidth then
      charMaxWidth := nkPrinter.Canvas.TextWidth(IntToStr(i));
  end;

end;


{**************************************

@printBuffer
@@
@@printClipBoardprintFilesĂ΂

@
@@title
@@@̃^Cg
@@@spoolɎg閼OƂ͈Ⴄ
@@buffer
@@@钆ĝ

@߂l
@@Ȃ

**************************************}
procedure printBuffer(title, buffer: string);
var
  tmp             : string; // getStringWithPrintableWidthĂꏊ
  linebuffer      : string; // #13#10܂łPsobt@
  shouldDrawNumber      : boolean;// strinǵAsԍׂ?
  newPageCharExist: boolean; // s}[NH
  dy              : integer; // y̑
  y_bottom        : integer; // ̈EC  

  //========================================
  // \ȕɎ܂邾̕Ԃ
  //========================================
  function getStringWithPrintableWidth: string;
  var
    returnStr  : string;
    i          : integer;
    tablen     : integer;
  begin

    //--------------------------------
    // LinuBuffer̕[iHj
    //--------------------------------
    if lineBuffer<>'' then
    begin
      // ܂lineBufferɎcĂȂAsԍ͕KvȂ
      
      shouldDrawNumber := false;
    end
    else
    begin
      // LineBuffeȑꍇAbuffer#13#10܂ŕ[

      shouldDrawNumber := true;
      if pos(#$D#$A, buffer)<>0 then
      begin
        lineBuffer := copy(buffer, 1, pos(#13#10, buffer)-1); //#13#10̒O܂
        delete(buffer, 1, Length(lineBuffer)+2);                 //#13#10܂Ŕ
      end
      else
      begin
        // #13#10AׂlineBufferɓ
        lineBuffer := buffer;
        buffer := '';
      end;
    end;


    //----------------------------------
    // \ȕ̕
    // lineBufferAreturnStrɈꕶAł邩ׂ
    //----------------------------------
    returnStr := '';

    while nkPrinter.Canvas.TextWidth(returnStr)
      < Sheet.WordRegionWidth - Sheet.NumberRegion - Sheet.SpaceRegion do
    begin
      Application.ProcessMessages;

      if linebuffer='' then break;

      // ^ȕꍇ
      if lineBuffer[1]=#9 then
      begin
        assert(ConfigForm.tabSpaceSpinBox.Value>=0);

        if ConfigForm.tabSpaceSpinBox.Value > 0 then
        begin
          tablen :=(Length(returnStr) mod ConfigForm.tabSpaceSpinBox.Value) + 1;
          for i:=tablen to ConfigForm.tabSpaceSpinBox.Value do
            returnStr := returnStr + ' ';
        end;

        delete(linebuffer,1,1); // tab폜
        continue; // continue;
      end;
      
      // s}[NLŁAs}[NƂ
      if (lineBuffer[1]=chr($0C))and(ConfigForm.newPageCharAvailable.Checked) then
      begin

        //*** bufferŁAŌ#13#10ƂłA#13#10Ă܂EEE
        delete(lineBuffer,1,1);
        buffer := lineBuffer + #13#10 + buffer; // linebuffer̒gAbufferɖ߂Ă
        lineBuffer := ''; // ɍsԍ悤ɂ
        result := returnStr;
        newPageCharExist := true;
        exit; // exit
      end;

      // ^uȊÕRg[R[h̏ꍇ or sR[h邯ǁAsR[h̎
      if lineBuffer[1] in BinChars then
      begin
        returnStr := returnStr + nonPrintableChar;
        delete(lineBuffer,1,1);
        continue; // continue
      end;

      // Rg[R[hᖳꍇ

      if ByteType(linebuffer,1)=mbLeadByte then
      // leabBytȅꍇ
      begin
        returnStr := returnStr + lineBuffer[1] + lineBuffer[2];
        delete(linebuffer,1,2);
      end
      else
      // ȊO(trail bytesingle Bytȅꍇ)
      begin
        returnStr := returnStr + lineBuffer[1];
        delete(linebuffer,1,1);
      end;

    end;

    result := returnStr;

  end; { getStringWithPrintableWidth}

begin

  // set header of each file 
  headerTitle := title;
  headerTime := UTimeString.getTimeString;

  // get PageMin(Max) Info from SpinEdit
  try
    PageMin := Min(ConfigForm.PageMinSpinEdit.Value, ConfigForm.PageMaxSpinEdit.Value);
    PageMax := Max(ConfigForm.PageMinSpinEdit.Value, ConfigForm.PageMaxSpinEdit.Value);
  except
    PageMin := 1;
    PageMax := 999;
  end;

  // buffer̓eLF/CRɕW
  buffer := AdjustLineBreaks(buffer);

  // t@Cς(Vt@C)̂ŁA_y[Wς
  LineNumber    := 0;
  pageNo        := 0;

  newLogicalPage; //ĂԂƁApageNo1āA1ɂȂ

  // ʁXabsƂȂƃ_BЕ̉\
  dy := Abs(nkPrinter.Canvas.Font.Height) + Abs(configForm.LineSpaceHeight.Value); 

  With Sheet do
    y_bottom := FrameTMar+InfoFrameHeight+RegionTMar+WordRegionHeight; 

  while not((buffer='')and(lineBuffer='')) do // ȂAI
    begin
      Application.ProcessMessages;

      newPageCharExist := false;
      tmp := getStringWithPrintableWidth;

      // sȂݒȂAwhile[vɖ߂
      if (tmp='') AND (ConfigForm.IgnoreBlankColChkBox.Checked) then continue;

      //āAɈ邽߂yW𑝂₷
      if pageMin<=pageNo then
      begin
        if shouldDrawNumber=true then
        begin
          Inc(LineNumber);     // ŏ̂Ps̎ALineNumber𑝂₷
          // ԍ
          nkPrinter.Canvas.TextOut(numberx-nkPrinter.Canvas.TextWidth(IntToStr(LineNumber)),y,IntToStr(LineNumber));
        end;
        nkPrinter.Canvas.TextOut(x,y,tmp);
      end;
      y := y + dy;

      // A炠ӂ鎞 or sR[hƂ
      if (newPageCharExist)or(y+dy >= y_bottom) then
      begin
        Application.ProcessMessages;
        if NewLogicalPage=false then break; // newLogicalPage֐Ăł
      end;

    end;

end;


{ ****************************

  getFileContents
    file̒gbufferɓ

  
  @filename: string
      t@C(full path)
    var buffer: string
      t@C̒gi[buffer

  ߂l
  @bufferɎ擾łǂ

******************************** }
function getFileContents(filename: string; var buffer: string): boolean;
begin
  result := false; // t@C̓e擾s

  if copy(filename,2,2)<>':\' then // hCun܂ȂƂ
  begin
    if copy(filename,1,2)<>'\\' then // \\Ŏn܂UNC?
    begin
      if getCurrentDir[Length(getCurrentDir)]='\' then
        fileName := getCurrentDir + filename
      else
        fileName := getCurrentDir + '\' + filename;
    end;
  end;

  filename := toLongFileName(filename);

  if not FileExists(filename) then
  begin
    MessageDlg(FileName+' ݂͑܂', mtWarning, [mbOk], 0);
    exit;
  end;

  try
    buffer := ReadFullyFromFile(fileName, true); // 2nd argtruéAR[h̕ϊw
  except
    on EOutOfMemory do exit;
    on EInOutError do exit;
    on ENotTextFileError do
      begin
        if MessageDlg(FileName+#13#10+'̓oCit@C̉\L܂'#13#10'܂H', mtConfirmation, [mbYes, mbNo], 0)<>mrYes then
          exit;
      end;
  end;

  result := true;

end;


{************************

  printClipBoard
@@clipboard̒g

  
  @title
      ̃^Cg
@@buffer
@@@钆ĝ

  ߂l
  @ɗv̐

**************************}
                       
function printClipBoard(title, buffer: string): integer;
begin

  totalSheets := 0;

  beginDocument(title);
  printBuffer(title, buffer);
  endDocument;

  result := totalSheets;

end;

{ ****************************

@printFiles

  
    files
      filẽXg(full path name)
    nextFileWithNewSheet
      fileɁAEy[W͋l߂邩ǂ

  ߂l
  @ɗv̖

**************************** }

function printFiles(files: TStringList; nextFileWithNewSheet: boolean): integer;
var
  i                        : Integer;
  buffer                   : string;
  papers                   : integer;
begin

  papers := 0;
  nFiles := files.count;

  if nextFileWithNewSheet then
  begin
    // l߂Ȃň

    for i:=0 to files.count-1 do
    begin
      totalSheets := 0;

      beginDocument(ExtractFileName(files.Strings[i]));

      if getFileContents(files.strings[i], buffer)=false then continue;
      printBuffer(ExtractFileName(files.Strings[i]), buffer);

      papers := papers + totalSheets;
      
      endDocument;
    end;
  end
  else
  begin
    // l߂Ĉ

    totalSheets := 0; 
    beginDocument('a2pr');

    for i:=0 to files.count-1 do
    begin
      if getFileContents(files.strings[i], buffer)=false then continue;
      printBuffer(ExtractFileName(files.Strings[i]), buffer);
    end;

    endDocument;
    papers := papers + totalSheets;
    
  end;

  result := papers;

end;

{*********************************

  beginDocument

  Tv
  @OɁA̕ȂǁAݒ肵B
  @ŁABeginDocĂł

  
  @spoolName
      vgj^[ɕ\Ƃ̖O

  ߂l
  @Ȃ

***********************************}
procedure beginDocument(spoolName: string);
begin


  // w
  if nkPcOrientation in NkPrinter.PrintCaps then
  begin
    if configForm.isLandscape.Checked then
    begin
      NkPrinter.Orientation := nkOrLandscape;
    end
    else
    begin
      NkPrinter.Orientation := nkOrPortrait;
    end;
    NkPrinter.ApplySettings;
  end;

  NkPrinter.BeginDoc(spoolName);

  // v^[̃tHgAFontDialogɂ킹
  nkPrinter.Canvas.Font.Size := Form1.FontDialog1.Font.Size;
  nkPrinter.Canvas.Font.Name := Form1.FontDialog1.Font.Name;
  nkPrinter.Canvas.Font.Pitch := Form1.FontDialog1.Font.Pitch;

  // tHg̑傫ɁASheetp̊e萔̐ݒ
  SheetInitialize;

  spoolJustCreated := true;

end;

{***********************

  endDocument
  @beginDocuent֐ƐƂ邽߂ɑ

  
  @Ȃ

  ߂l
  @Ȃ

************************}

procedure endDocument;
begin
  NkPrinter.EndDoc;
end;

{**********************************
  ɁAPageMin4APageMax7łA
  ۂ3`8y[WB

  ֐ɓnpageNoA38̊Ԃ
  Ă邩𒲂ׂ֐

************************************}
function insidePageRange(pageNo: integer) : boolean;
var
  min, max: integer;
begin
  if PageMin mod 2 = 0 then
    min := PageMin - 1
  else
    min := PageMin;

  if PageMax mod 2 = 0 then
    max := PageMax
  else
    max := PageMax + 1;

  if (min<=pageNo)and(pageNo<max) then
    result := true
  else
    result := false;

end;

{**********************************
@
@NewLogicalPage
    V_y[Wn߂

  
  @Ȃ

  ߂l
    P̃t@CŁAy[W
    PageMaxAfalseԂ
***********************************}
function NewLogicalPage: boolean;
begin

  Result := true;

  if nfiles>1 then
  begin
    // t@C

    if (pageNo=0)and(totalSheets=0) then
    begin
      pageLeftRight := leftPage;
      Inc(totalSheets);
    end
    else if pageLeftRight=leftPage then
    begin
      // ܂܂ōy[WĂ
      pageLeftRight := rightPage;
    end
    else
    begin
      // ܂܂ŉEy[WĂ
      nkPrinter.NewPage;
      Inc(totalSheets);
      pageLeftRight := leftPage;
    end;

    Inc(pageNo); // draw frameł邱ƁI
    DrawFrame;
  end   { nfiles >1 }
  else
  begin
    { Pt@C
    @Pt@C̎́Ay[Wwl
    @

      w肪4`7y[WƂƁA
        1 2 ... 1
        3 4 ... 2
        5 6 ... 3
        7 8 ... 4
    @3y[Wڂ͍y[WȂ̂ŁAꏏɈA
      7y[WڂȂ̂ŁAE8ꏏɈ
    @3`8y[W邱ƂɂȂB }

    if (pageNo=0)and(totalSheets=0) then
    begin
      pageLeftRight := leftPage;
      Inc(totalSheets);
    end
    else if pageLeftRight=leftPage then
    begin
      // ܂܂ōy[WĂ
      pageLeftRight := rightPage;
    end
    else
    begin
      // ܂܂ŉEy[WĂ
      nkPrinter.NewPage;
      Inc(totalSheets);
      pageLeftRight := leftPage;
    end;

    Inc(pageNo); // drawframeł邱ƁI
    DrawFrame;

  end;

  // Jnʒuݒ
  with Sheet do
  begin
    if pageLeftRight=leftPage then
      x := FrameLMar+RegionLMar
    else
      x := FrameLMar+RegionLMar+(WordFrameWidth+FrameMidMar);

    if ConfigForm.PrintHeader.Checked then
      y := FrameTMar+InfoFrameHeight+RegionTMar
    else
    begin
      assert(InfoFrameHeight=0);
      y := FrameTMar+RegionTMar;
    end;

  end;

  // sԍKvȂA̕炷
  if ConfigForm.PrintLineNumberChkBox.Checked then
  begin
    with Sheet do
    begin
      NumberRegion := charMaxWidth*(Length(IntToStr(LineNumber+100)));
      SpaceRegion := charMaxWidth * 2;
      numberx := x + NumberRegion - RegionLMar div 2;// s\鎞AJnʒuƍɂ炷
      x := numberx + SpaceRegion;
    end
  end
  else
  begin
    Sheet.NumberRegion := 0;
    Sheet.SpaceRegion := 0;
  end;

end;


{***************************************

@DrawFrame
    t[`i^CgƂj
    FrameȂoptiontitleȂoptionŏ

  
  @Ȃ

  ߂l
  @Ȃ

****************************************}
procedure DrawFrame;
var
  shift       : integer;
  tmpStr      : string;
  orgFontSize : Integer;
begin

  assert(pageNo>=PageMin);

  if pageLeftRight=leftPage then
    shift := 0
  else
    shift := Sheet.WordFrameWidth + Sheet.FrameMidMar;


  with nkPrinter.Canvas do
  begin
    Pen.Width := 4;
    with Sheet do
    begin
      // g
      if ConfigForm.PrintFrameLine.Checked then
      begin
        // info
        if ConfigForm.PrintHeader.Checked then
        begin
          // Info Frame
          assert(InfoFrameHeight>0);
          Rectangle(FrameLMar+shift,FrameTMar,FrameLMar+WordFrameWidth+shift,FrameTMar+InfoFrameHeight);
        end
        else
        begin
          assert(InfoFrameHeight=0);
          assert(InfoFrameTBMar=0);
        end;
        // word Frame
        Rectangle(FrameLMar+shift,FrameTMar+InfoFrameHeight,FrameLMar+WordFrameWidth+shift,FrameTMar+InfoFrameHeight+WordFrameHeight);
      end;


      if ConfigForm.PrintHeader.Checked then
      begin
        assert(InfoFrameHeight>0);
        assert(InfoFrameTBMar>0);
        Font.Style := Font.Style + [fsBold];
        orgFontSize := nkPrinter.Canvas.Font.Size;

        { ^Cg }
        Font.Size := orgFontSize + 2;
        tmpStr := ExtractFileName(headerTitle);
        TextOut(FrameLMar+shift+(WordFrameWidth div 2)-(nkPrinter.Canvas.TextWidth(tmpStr) div 2),
                            FrameTMar+InfoFrameTBMar, tmpStr);
        Font.Size := orgFontSize + 1;

        { y[Wԍ }
        tmpStr := 'Page' + IntToStr(PageNo);
        TextOut(FrameLMar+shift+WordFrameWidth-RegionRMar-nkPrinter.Canvas.TextWidth(tmpStr),
                FrameTMar+InfoFrameTBMar, tmpStr);

        { tA (sS?) }
        TextOut(FrameLMar+shift+RegionLMar,FrameTMar+InfoFrameTBMar,headerTime);

        { tHg߂ }
        Font.Style := Font.Style - [fsBold];
        Font.Size := orgFontSize;

      end; // if configform.printheader.checked

    end; // with sheet do

  end; // with nkprinter.canvas do

end;

end.




