unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellAPI, Buttons, clipbrd, Inifiles, Spin,

  about, readFileAll, UPrint, UConfig, ExtCtrls, FormRgn,
  Menus, NkPrinters, TrayIcon;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    FontDialog1: TFontDialog;
    FormRgn1: TFormRgn;
    PopupMenu1: TPopupMenu;
    PrintFileMenu: TMenuItem;
    PrintClipBoardMenu: TMenuItem;
    N1: TMenuItem;
    ConfigMenu: TMenuItem;
    FontChangeMenu: TMenuItem;
    PrinterSetupMenu: TMenuItem;
    N2: TMenuItem;
    ExitMenu: TMenuItem;
    aboutMenu: TMenuItem;
    NkPrinterSetupDialog1: TNkPrinterSetupDialog;
    ChangeSize: TMenuItem;
    NormalSizeIcon: TImage;
    DoubleSizeIcon: TImage;
    StayOnTop: TMenuItem;
    TrayIcon1: TTrayIcon;
    procedure FormCreate(Sender: TObject);
    procedure FormRgn1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PrintFileMenuClick(Sender: TObject);
    procedure PrintClipBoardMenuClick(Sender: TObject);
    procedure ExitMenuClick(Sender: TObject);
    procedure aboutMenuClick(Sender: TObject);
    procedure PrinterSetupMenuClick(Sender: TObject);
    procedure FontChangeMenuClick(Sender: TObject);
    procedure ConfigMenuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ChangeSizeClick(Sender: TObject);
    procedure StayOnTopClick(Sender: TObject);
  private
    { Private 錾 }
    //procedure SetShowOption(NeedOption: boolean);
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure FilePrintDialog(Files: TStringList; confirm: boolean);
//    procedure HandleCommandLine;
    procedure RedrawForm;
  end;

var
  Form1: TForm1;

const
  appName = 'ȃGl';

implementation

uses print_clipboard, longfilename;

{$R *.DFM}


procedure TForm1.CreateParams(var Params: TCreateParams);
begin
  // drag󂯓ݒ
  inherited CreateParams(Params);
  Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;


{***********************************
 * tH[̍쐬
 *
 * 郁j[ł̏͂ōs
 **********************************}
procedure TForm1.FormCreate(Sender: TObject);
var
  setting: TIniFile;
  Files  : TStringList;
  i      : integer;
begin
  // printer̐ݒ
  try
    nkprinter.Index := -1;
  except
    MessageDlg('ftHg̃v^[ݒ肳Ă܂', mtWarning, [mbOK], 0);
    Application.Terminate;
    {SetDefaultPrinter(0);
    nkPrinter.ForceUpdate;}
  end;


  // tH[̈ʒu߂ƃTCY̌
  setting := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  with setting do
  begin
    Form1.Left := ReadInteger('Position', 'left', 100);
    Form1.Top  := ReadInteger('Position', 'top',  100);
    ChangeSize.Checked := ReadBool('Position', 'enlarged', false);
    StayOnTop.Checked := ReadBool('Position','stayontop', false);
    free;
  end;

  if StayOnTop.Checked then
    Form1.FormStyle := fsStayOnTop
  else
    Form1.FormStyle := fsNormal;

  // ȉconfig̓eĝłō쐬Ă
  ConfigForm := TConfigForm.Create(Application);

  RedrawForm;

  if Form1.Left > screen.Width-Form1.Width then
    Form1.Left := screen.Width-Form1.Width;
  if Form1.top > screen.Height-Form1.Height then
    Form1.Top := screen.Height-Form1.Height;
  if Form1.Left < 0 then
    Form1.Left := 0;
  if Form1.Top < 0 then
    Form1.Top := 0;



  // 郁j[ł̈
  if ParamCount>0 then
  begin
    Files := TStringList.Create;
    for i:=1 to paramCount do
      Files.Add(paramStr(i));
    FilePrintDialog(Files, false);
    Files.Free;
    //HandleCommandLine;
    Application.Terminate;
  end;

  // tH[̃^Cg̐ݒ
  Form1.Caption := appName;


end;

{**************************************************
 * 郁j[AR}hCIvV̓
 * gp
 *************************************************}
{procedure TForm1.HandleCommandLine;
var
  i    : integer;
  Files: TStringList;
  tmpstr:string;
  orgPrintLineNumber: boolean;
  orgTabSpace       : Integer;
begin
  // configForm̒lޔ
  orgPrintLineNumber := ConfigForm.PrintLineNumberChkBox.Checked;
  orgTabSpace        := ConfigForm.tabSpaceSpinBox.Value;

  // sendToł̃ftHg̒lZbg
  ConfigForm.PrintLineNumberChkBox.Checked := false;

  Files := TStringList.Create;
  try

    try
      for i:=1 to paramCount do
      begin
        if paramStr(i)[1]='-' then
        begin
          tmpstr := paramStr(i);
          delete(tmpstr,1,1);
          case tmpstr[1] of
            'n':
              begin
                ConfigForm.PrintLineNumberChkBox.Checked := true;
              end;
            't':
              begin
                delete(tmpstr,1,1);
                ConfigForm.tabSpaceSpinBox.Value := StrToInt(tmpstr);
              end;
          else
            raise Exception.create('G[ł');
          end;
        end
        else
          Files.Add(paramStr(i));
      end;

      // `FbNpɓꂽIIIIIIIIIIIIIIIIIIIIIIIIP
     /*tmpstr :=''#13#10+'^u'+IntToStr(ConfigForm.TabSpaceSpinBox.Value)+#13#10;
     if ConfigForm.PrintLineNumberChkBox.Checked then
       tmpStr := tmpStr + 'sԍ'
     else
       tmpStr := tmpStr + 'sԍ';

     MessageDlg(tmpstr,mtError,[mbOK],0);*/


      FilePrintDialog(Files, false);
    finally
      Files.Free;
      ConfigForm.PrintLineNumberChkBox.Checked := orgPrintLineNumber;
      ConfigForm.tabSpaceSpinBox.Value         := orgTabSpace;
    end;

  except
    MessageDlg('R}hCp[^sł',mtError,[mbOK],0);
  end;


end;}


{***********************************
 * t@C̃hbvɂI[v
 *
 * Iꂽt@C̃XgFilesɓA
 * FilePrintDialogɓn
 *******************************}
procedure TForm1.WMDropFiles(var Msg: TWMDropFiles);
var
  Files : TStringList;
  FileNameChars : array [0..255] of char;
  i: integer;
  NumFiles: integer;
begin
  // dropꂽt@C̐𓾂
  NumFiles := DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0);

  if NumFiles>0 then
    begin
      Files := TStringList.Create;
      for i:=1 to NumFiles do
        begin
          DragQueryFile(Msg.Drop, i-1, FileNameChars, SizeOf(FileNameChars));
          Files.Add(StrPas(FileNameChars));
        end;
      FilePrintDialog(Files, not ConfigForm.ignoreConfirmChkBox.Checked);
      Files.Free;
    end;
end;

{*********************************************************
 * t@C̈ŋʂōs
 *
 * ́AۂɈt@C̃Xgn
 * mFȂݒɂȂĂꍇA_CAO͕\Ȃ
 * 郁j[łconfirmfalseŌĂяo
 *********************************************************}
procedure TForm1.FilePrintDialog(Files: TStringList; confirm: boolean);
var
  tmpStr: string;
  i: integer;
  totalSheets: integer; // g[^̖̎
begin

  // 邩ǂ̊mF
  if confirm then
  begin
    // _CAOŕ\镶쐬
    tmpStr := 'ȉ̃t@C܂' +#13#10;
    for i:=0 to Files.Count-1 do
      tmpStr := tmpStr + #13#10 + toLongFileName(Files.Strings[i]);

    //if Application.MessageBox(PChar(tmpStr),PChar(appName),mb_OKcancel)<>IDOK then
    // messageboxƁAOɂȂĂ[
    if MessageDlg(tmpstr, mtConfirmation, [mbYes, mbNo], 0)<>mrYes then
      Exit; // ȂȂAExit
  end;

  totalSheets := printFiles(files, not ConfigForm.Tumeru.Checked); // fileςƂAnewsheet

  // ̕\
  if confirm then
    MessageDlg('I܂'#13#10#13#10'g[^ '+IntToStr(totalSheets),mtInformation,[mbOk],0);

end;


procedure TForm1.FormRgn1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ssLeft in Shift then
  begin
    ReleaseCapture;
    SendMessage(Handle,WM_SYSCOMMAND, SC_MOVE or 2, MakeLong(X, Y));
  end;
end;


{*******************************
 * FileOpenDialogɂI[v
 *
 * Iꂽt@C̃XgFilesɓA
 * FilePrintDialogɓn
 *******************************}
procedure TForm1.PrintFileMenuClick(Sender: TObject);
var
  i: integer;
  Files: TStringList;
begin
  if OpenDialog1.Execute then
    begin
      Files := TStringList.Create;
      for i:=0 to OpenDialog1.Files.Count-1 do
        Files.Add(OpenDialog1.Files.Strings[i]);
      FilePrintDialog(Files, not ConfigForm.ignoreConfirmChkBox.Checked);
      Files.Free;
    end;
end;


{******************************************
 *  Nbv{[ḧ{^Ƃ
 ******************************************}
procedure TForm1.PrintClipBoardMenuClick(Sender: TObject);
var
  clipBrd: TClipBoard;
  buffer: String;
  totalSheets : integer;
begin
  clipBrd := clipboard;
  if not clipBrd.HasFormat(CF_TEXT) then
    begin
      MessageDlg('Nbv{[h̒geLXgł͂܂', mtError, [mbOk], 0);
      Exit;
    end;

  Buffer := clipBrd.AsText;
  ClipBoardPrintDialog.ClipboardNakami.Text := copy(buffer,1, 200);
  if ClipboardPrintDialog.ShowModal=mrOK then
  begin
    totalSheets := printClipBoard(ClipboardPrintDialog.ClipboardTitle.Text,buffer);
    // ̕\
    if not ConfigForm.ignoreConfirmChkBox.Checked then
      MessageDlg('I܂'#13#10#13#10'g[^ '+IntToStr(totalSheets),mtInformation,[mbOk],0);
  end;

end;


procedure TForm1.ExitMenuClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.aboutMenuClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;


{*********************************
 *@v^[̐ݒDialog̕\
 *  ۂ̃v^[̐ݒ́Aɍs
 *********************************}
procedure TForm1.PrinterSetupMenuClick(Sender: TObject);
begin
  nkprinterSetupDialog1.Execute;
end;


{***************************************
 * FontDialogɂtHg̐ݒ
 * ۂPrinterFontFontDialogɍ킹̂
 * O
 ***************************************}
procedure TForm1.FontChangeMenuClick(Sender: TObject);
begin
  FontDialog1.Execute;
end;

procedure TForm1.ConfigMenuClick(Sender: TObject);
begin
  ConfigForm.ShowModal;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  setting: TIniFile;
begin
  // tH[̈ʒuۑ
  setting := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  with setting do
  begin
    WriteInteger('Position', 'left', Form1.Left);
    WriteInteger('Position', 'top',  Form1.Top);
    WriteBool('Position', 'enlarged', ChangeSize.Checked);
    WriteBool('Position', 'stayontop', StayOnTop.Checked);
    free;
  end;

end;

procedure TForm1.ChangeSizeClick(Sender: TObject);
begin
  ChangeSize.Checked := not ChangeSize.Checked;
  RedrawForm;
end;

procedure TForm1.StayOnTopClick(Sender: TObject);
begin
  StayOnTop.Checked := not StayOnTop.Checked;
  if StayOnTop.Checked then
    Form1.FormStyle := fsStayOnTop
  else
    Form1.FormStyle := fsNormal;

  RedrawForm;
end;

procedure TForm1.RedrawForm;  // stayontopςƂɂĂԕKv̂ŁA
var
  tmpleft, tmptop : Integer;
begin
  TrayIcon1.Visible := false;

  tmpleft := Form1.Left;
  tmptop  := Form1.Top;

  if ChangeSize.Checked then
    FormRgn1.Picture := DoubleSizeIcon.Picture
  else
    FormRgn1.Picture := NormalSizeIcon.Picture;

  Form1.Width := FormRgn1.Width;
  Form1.Height := FormRgn1.Height;

  FormRgn1.UpdateRgn;

  Form1.Left := tmpleft;
  Form1.Top  := tmptop;

  if ConfigForm.HideTaskbar.Checked then
    TrayIcon1.Visible := true
  else
    TrayIcon1.Visible := false;


end;

end.
