unit openbrowser3;

interface

uses
  classes, forms, sysutils ,shellapi;

type

  EBrowserNotFoundError  = exception;
  TFileName = string;

  TBrowser = class
  private
    FBrowser, FURL  : string;
    procedure Open;
    //procedure AppendProtcol;
  public
    procedure GetBrowser;
    procedure Show;
    procedure SetURL(vURL: String);
  end;

{ shellOpenŊJƂAsA
  registry瓾browserŁAwinexecs  }
procedure OpenURL(URL: string);

{ ŏ.htmɊ֘AtꂽuEU[𒲂ׁA
  ̃uEU[DDEgĊJ }
procedure OpenURLUsingDDE(URL: string);






implementation

uses
  registry, windows, DDEMan, dialogs;

var
  browsername: string;

{find exe-file of default browser}
function GuessBrowser (fileName: TFileName): TFileName; forward;
{load a URL}
procedure LoadURL(sBrowerPrgFile, sServiceName, sURL: string); forward;
{load a local file}
procedure ShowFile(sBrowerPrgFile, sServiceName, sFilename: string); forward;
{query browser for info on local file}
function URLInfo(sBrowerPrgFile, sServiceName: string; Netscape: boolean; var Title: string): pChar; forward;
{make brower save URL to local file}
procedure StoreURL(sBrowerPrgFile, sServiceName, sURL, sStoreFilename: string);forward;


{*** JĂ郁\bĥP ***}
procedure OpenURL(URL: string);
begin
  with TBrowser.Create do
  begin
    GetBrowser;
    SetURL(URL);
    Show;
    Free;
  end;
end;

{*** JĂ郁\bĥQ ***}
procedure OpenURLUsingDDE(URL: string);
begin
  if Pos('NET',UpperCase(BrowserName))<>0 then
    LoadURL(BrowserName, 'Netscape', URL)
  else
    LoadURL(BrowserName, 'iexplore', URL)
end;



procedure TBrowser.GetBrowser;
(*
 * Tv
 *)
const
  Netscape = 'NETSCAPE.EXE';
var
  PBrowser: PChar;
  tmpBrowser: String;

  function GetRegValue(vAddress: String): String;
  var
    hReg: HKEY;
    RegType: DWORD;
    VarSize: DWORD;
  begin
    Result := '';
    hReg := 0;

    RegOpenKeyEx(HKEY_CLASSES_ROOT, PChar(vAddress), 0, KEY_QUERY_VALUE, hReg);
    try
      SetLength(Result, $ff);
      RegType := REG_SZ;
      VarSize := Length(Result);
      RegQueryValueEx(hReg, '', nil, @RegType, PByte(PChar(Result)), @VarSize);
      SetLength(Result, VarSize - 1);
    finally
      RegCloseKey(hReg);
    end;
  end;

  procedure Remove(vStr: String); // Delete ֐Œu
  var
    CommandPos: Integer;
  begin
    CommandPos := AnsiPos(vStr, FBrowser);
    if (CommandPos > 0) then
      FBrowser :=
        Copy(FBrowser, 1, CommandPos - 1) +
        Copy(FBrowser, CommandPos + 2, Length(FBrowser));
  end;

begin
  FBrowser := GetRegValue((GetRegValue('.htm') + '\shell\open\command'));

  if (FBrowser <> '') then begin
    if (AnsiPos(Netscape, FBrowser) > 0) then begin
      Remove('-H');
      Remove('/H');
    end;

    Remove('%1');
    Remove('""');
    Remove('''' + '''');

    FBrowser := Trim(FBrowser);
    PBrowser := PChar(FBrowser);
    tmpBrowser := AnsiExtractQuotedStr(PBrowser, '"');
    if (tmpBrowser <> '') then
      FBrowser := tmpBrowser;
  end;
end;

{
procedure TBrowser.AppendProtcol;
(*
 * Tv
 *)
var
  Fields: TStringList;
  tmpURL: String;
begin
  Fields := TStringList.Create;
  try
    tmpURL := FURL;
    UniqueString(tmpURL);
    ExtractHTTPFields([':'], [], PChar(tmpURL), Fields);
    if (Fields.Count = 0) then
      FURL := 'http://' + FURL;
  finally
    Fields.Free;
  end;
end;}

procedure TBrowser.SetURL(vURL: String);
(*
 * Tv  URL ݒ肷
 *   URL  Setter
 *)
begin
  if (FURL = vURL) then
    Exit;

  FURL := vURL;
  //AppendProtcol;
  {if (FAuto) then
    Show;}
end;

procedure TBrowser.Open;
(*
 * Tv
 *)
begin
  // sȂ݂EEE
  WinExec(PChar(AnsiQuotedStr(FBrowser, '"') + ' ' + FURL), SW_SHOW);
end;

procedure TBrowser.Show;
(*
 * Tv
 *)
var
  ErrResult: Integer;
begin
  ErrResult := ShellExecute(0, 'open', PChar(FURL), nil, nil, SW_HIDE);
  if (ErrResult <> 2) and (ErrResult <= 32) then
    Open;
end;


function GuessBrowser (fileName: TFileName): TFileName;
{find browser associated with the extension of
filename. Since file must exist we create a dummy file if filename is empty or
doesn't exist}
const
	prefix: pchar = 'htm';
var
	Dir, Name: string;
  res: array[1..250] of char;
//  i: integer;
  err: integer;
  F: TFileStream;
  dummyFileCreated: boolean;
begin
  dummyFileCreated := false;
	if (fileName = '') or not fileexists (fileName) then
  begin
  	filename:= extractfilepath(application.exename) + '~~~~~~~~.htm';
  	F:= TFileStream.create (filename,fmCreate);
    F.free;
    dummyFileCreated:= true;
  end;
	Dir:= extractFilePath(FileName) + #0;
  Name:= extractFileName(FileName) +  #0;
  fillchar(res,SizeOf(res),' ');
  res[250]:= #0;
  err:= FindExecutable(@Name[1],@Dir[1],@res);
  if err >= 32 then
    result:= strPas(@res)
	else
  	result:= '';
  if dummyFileCreated then
  	deletefile(PChar(filename));
end;


procedure LoadURL(sBrowerPrgFile, sServiceName, sURL: string);
{ Bring browser to front and load a URL
	sBrowerPrgFile: Full pathname of browser exe-file
  sServiceName: Name of Browser's DDE-Service
  							'Netscape' for all Netscape Browsers
                'iexplore' for Internet Explorer
  sURL: ULR to load
}

var
  ddeClientConv : TDDEClientConv;
begin
  if (sBrowerPrgFile = '') or (not FileExists(sBrowerPrgFile)) then
    raise EBrowserNotFoundError.create('Das angegebene Browserprogramm exitiert nicht!');


  ddeClientConv := TDDEClientConv.Create( nil );
  try
    with ddeClientConv do
    begin
      ServiceApplication := sBrowerPrgFile;

      SetLink( sServiceName,'WWW_Activate');
      RequestData('0xFFFFFFFF'); // ȂAŗ̂ŁAfrontɎĂ̂͂߂悤}
      //StrDispose(retchar);

      if SetLink( sServiceName,'WWW_OpenURL') then
      begin
        RequestData(sURL + ',,0xFFFFFFFF,0x3,,,');
        //StrDispose(retchar);
        CloseLink;
      end;
    end;

  finally
    ddeClientConv.Free;
  end;
end;

procedure ShowFile(sBrowerPrgFile, sServiceName, sFilename: string);
{ Bring browser to front and load a local file
	sBrowerPrgFile: Full pathname of browser exe-file
  sServiceName: Name of Browser's DDE-Service
  							'Netscape' for all Netscape Browsers
                'iexplore' for Internet Explorer
  sURL: ULR to load
}

var
	ddeClientConv : TDDEClientConv;
        retchar       : PChar;
begin
	if (sBrowerPrgFile = '') or (not FileExists(sBrowerPrgFile)) then
		raise EBrowserNotFoundError.create('Das angegebene Browserprogramm exitiert nicht!');

	ddeClientConv:= TDDEClientConv.Create( nil );
  try
    with ddeClientConv do
    begin
      ServiceApplication := sBrowerPrgFile;
      SetLink( sServiceName,'WWW_Activate');
      retchar := RequestData('0xFFFFFFFF');
      //StrDispose(retchar);
      SetLink(sServiceName,'WWW_ShowFile');
      retchar := RequestData(sFilename + ',,0xFFFFFFFF');
      //StrDispose(retchar);
      CloseLink;
  	end;
  finally
  	ddeClientConv.Free;
  end;
end;


procedure StoreURL(sBrowerPrgFile, sServiceName, sURL, sStoreFilename: string);
{ make browser save a URL to a local file
	sBrowerPrgFile: Full pathname of browser exe-file
  sServiceName: Name of Browser's DDE-Service
  							'Netscape' for all Netscape Browsers
                'iexplore' for Internet Explorer
  sStoreFilename: Filename to store URL in
  sURL: ULR to load
}

var
	ddeClientConv : TDDEClientConv;
        retchar       : PChar;
begin
	if (sBrowerPrgFile = '') or (not FileExists(sBrowerPrgFile)) then
		raise EBrowserNotFoundError.create('Das angegebene Browserprogramm exitiert nicht!');

	ddeClientConv:= TDDEClientConv.Create( nil );
  try
    with ddeClientConv do
    begin
    	ServiceApplication := sBrowerPrgFile;
      SetLink( sServiceName,'WWW_Activate');
      retchar := RequestData('0xFFFFFFFF');
      //StrDispose(retchar);
      SetLink(sServiceName,'WWW_OpenURL');
      retchar := RequestData(sURL + ',' + sStoreFilename + ',0xFFFFFFFF,0x3,,,');
      //StrDispose(retchar);
      CloseLink;
  	end;
  finally
  	ddeClientConv.Free;
  end;
end;


function URLInfo(sBrowerPrgFile, sServiceName: string; Netscape: boolean; var Title: string): pChar;
{ query browser for info on loaded URL
  sBrowerPrgFile: Full pathname of browser exe-file
  sServiceName: Name of Browser's DDE-Service
  							'Netscape' for all Netscape Browsers
                'iexplore' for Internet Explorer
  Title: string variable to store title text
  returns: URL as pChar
}
var
	DDEClientConv: TDDEClientConv;
	StartPtr, EndPtr: pchar;
//  browserWinName: string;
begin
	result:= #0;
  Title:= '';

  if (sBrowerPrgFile = '') or (not FileExists(sBrowerPrgFile)) then
		raise EBrowserNotFoundError.create('Das angegebene Browserprogramm exitiert nicht!');

	ddeClientConv:= TDDEClientConv.Create( nil );
  try
    with ddeClientConv do
    begin
    	ServiceApplication := sBrowerPrgFile;
      SetLink( sServiceName,'WWW_GetWindowInfo');
      StartPtr:= RequestData('0xFFFFFFFF');
    end;
  finally
  	ddeClientConv.Free;
  end;

  if startPtr^ = #0 then
  	exit;
    {skip leading "}
    inc(StartPtr);
    EndPtr:= StartPtr;
    {proceed to next "}
    while (EndPtr^ <> '"') do
      inc(EndPtr);
    {terminate URL string}
    EndPtr^:= #0;
    result:= StartPtr;
    {skip ","}
    StartPtr:= EndPtr+3;
    if Netscape then
      inc(StartPtr,12);

    EndPtr:= StartPtr;
    if Netscape then
      while (EndPtr^ <> ']') do
        inc(EndPtr)
    else
      while (EndPtr^ <> '"') do
        inc(EndPtr);

    EndPtr^:= #0;
    Title:= strPas(StartPtr);
end;


initialization
  BrowserName := GuessBrowser('');

end.
