unit readFileAll;

interface

uses
  Sysutils;

type
  ENotTextFileError = class(Exception);

const
  binChars = [chr($00)..chr($8), chr($10)..chr($1F)]; // Rg[LN^[(^uȊO)

// G[ɂ̓_CAO{bNXo邪AraiseōĐĂ
// convert:booleańASJISɕϊ邩ǂ
function readFullyFromFile(FileName: string; convert: boolean): string;

implementation

uses
  Dialogs, jconvert;

function readFullyFromFile(FileName: string; convert: boolean): string;
var
  fSize : integer;
  F     : File of Byte;
  Buffer: PChar;
  Buff  : string;
  i     : integer;
  j     : integer;
  nBinChars: integer;

begin
  FileMode := 0; // t@C[h́Aǂݍݐp
  // t@C̃I[v
  try
    AssignFile(F, FileName);
    Reset(F);
  except
    on EInOutError do
      begin
        MessageDlg('t@CI[vł܂'#13#10+FileName, mtError, [mbOk], 0);
        raise;
      end;
  end;


  // ̊mۂƃt@C̓ǂݍ
  Buff := '';
  try
    fSize := FileSize(F);
    GetMem(Buffer, fSize+1); // ŌNULL邽߂Ƀt@CTCY+1m
    try
      BlockRead(F, Buffer^, fSize);
      // kLN^~߂ɂĂ
      Buffer[fSize] := #0;
      // string^ւ̕ϊ̂߁Ak̓Xy[XɕϊĂ
      for i:=0 to fSize-1 do
        if Buffer[i]=#0 then Buffer[i] := ' ';

      buff := StrPas(Buffer);
      if convert=true then
         buff := ConvertJCode(buff, SJIS_OUT);

      // oCit@Cǂ̔
      nBinChars := 0;
      j := 200; // binCharsǂf镶
      if Length(buff)<200 then j := Length(buff);

      for i:=1 to j do
        if buff[i] in BinChars then
            Inc(nBinChars);

      //MessageDlg('BinChars : '+IntToStr(nBinChars),mtCustom, [mbok],0);

      if nBinChars > (j div 10) then // 10%ȏオBinCharsȂAoCiƔf
        raise ENotTextFileError.Create('it is binary file');

    finally
      FreeMem(Buffer);
      closeFile(F);
      Result := buff;
    end;
  except
    on EOutOfMemory do
      begin
        MessageDlg('[mۂł܂', mtError, [mbOk], 0);
        raise;
      end;
  end;

end;

end.
